﻿using UnityEngine;
using System.Collections.Generic;

public class WaypointGraph
{

    public Graph navGraph;
    public List<GameObject> waypoints;
    public GameObject this[int i]
    {
        get { return waypoints[i]; }
        set { waypoints[i] = value; }
    }

    public WaypointGraph(GameObject waypointSet)
    {

        waypoints = new List<GameObject>();
        navGraph = new AdjacencyListGraph();

        findWaypoints(waypointSet);
        buildGraph();
    }

    private void findWaypoints(GameObject waypointSet)
    {

        if (waypointSet != null)
        {
            foreach (Transform t in waypointSet.transform)
            {
                waypoints.Add(t.gameObject);
            }
            Debug.Log("Found " + waypoints.Count + " waypoints.");

        }
        else
        {
            Debug.Log("No waypoints found.");

        }
    }

    private void buildGraph()
    {

        int n = waypoints.Count;

        navGraph = new AdjacencyListGraph();
        for (int i = 0; i < n; i++)
        {
            navGraph.addNode(i);
        }

        //------CourseWork 2

        navGraph.addEdge(0, 1, 1);

        // //------CourseWork 1


        // navGraph.addEdge(0, 1, 1);
        // navGraph.addEdge(0, 2, 1);

        // navGraph.addEdge(1, 4, 1);
        // navGraph.addEdge(1, 2, 1);

        // navGraph.addEdge(2, 3, 1);
        // navGraph.addEdge(2, 4, 1);

        // navGraph.addEdge(3, 5, 1);

        // navGraph.addEdge(4, 6, 1);
        // navGraph.addEdge(4, 3, 1);

        // navGraph.addEdge(5, 6, 1);
        // navGraph.addEdge(6, 7, 1);
        // navGraph.addEdge(6, 8, 1);

        // navGraph.addEdge(7, 8, 1);
        // navGraph.addEdge(7, 9, 1);

        // navGraph.addEdge(8, 11, 1);
        // navGraph.addEdge(8, 12, 1);

        // navGraph.addEdge(9, 10, 1);

        // navGraph.addEdge(10, 12, 1);
        // navGraph.addEdge(10, 13, 1);

        // navGraph.addEdge(11, 12, 1);

        // navGraph.addEdge(12, 13, 1);
        // navGraph.addEdge(12, 14, 1);

        // navGraph.addEdge(13, 14, 1);
        // navGraph.addEdge(13, 15, 1);

        // navGraph.addEdge(14, 15, 1);

        //------ALL EDGES


        // navGraph.addEdge(0, 1, 1);
        // navGraph.addEdge(0, 2, 1);
        // navGraph.addEdge(0, 3, 1);
        // navGraph.addEdge(0, 4, 1);
        // navGraph.addEdge(0, 5, 1);
        // navGraph.addEdge(0, 6, 1);
        // navGraph.addEdge(0, 7, 1);
        // navGraph.addEdge(0, 8, 1);
        // navGraph.addEdge(0, 9, 1);
        // navGraph.addEdge(0, 10, 1);
        // navGraph.addEdge(0, 11, 1);
        // navGraph.addEdge(0, 12, 1);
        // navGraph.addEdge(0, 13, 1);
        // navGraph.addEdge(0, 14, 1);
        // navGraph.addEdge(1, 2, 1);
        // navGraph.addEdge(1, 3, 1);
        // navGraph.addEdge(1, 4, 1);
        // navGraph.addEdge(1, 5, 1);
        // navGraph.addEdge(1, 6, 1);
        // navGraph.addEdge(1, 7, 1);
        // navGraph.addEdge(1, 8, 1);
        // navGraph.addEdge(1, 9, 1);
        // navGraph.addEdge(1, 10, 1);
        // navGraph.addEdge(1, 11, 1);
        // navGraph.addEdge(1, 12, 1);
        // navGraph.addEdge(1, 13, 1);
        // navGraph.addEdge(1, 14, 1);
        // navGraph.addEdge(2, 3, 1);
        // navGraph.addEdge(2, 4, 1);
        // navGraph.addEdge(2, 5, 1);
        // navGraph.addEdge(2, 6, 1);
        // navGraph.addEdge(2, 7, 1);
        // navGraph.addEdge(2, 8, 1);
        // navGraph.addEdge(2, 9, 1);
        // navGraph.addEdge(2, 10, 1);
        // navGraph.addEdge(2, 11, 1);
        // navGraph.addEdge(2, 12, 1);
        // navGraph.addEdge(2, 13, 1);
        // navGraph.addEdge(2, 14, 1);
        // navGraph.addEdge(3, 4, 1);
        // navGraph.addEdge(3, 5, 1);
        // navGraph.addEdge(3, 6, 1);
        // navGraph.addEdge(3, 7, 1);
        // navGraph.addEdge(3, 8, 1);
        // navGraph.addEdge(3, 9, 1);
        // navGraph.addEdge(3, 10, 1);
        // navGraph.addEdge(3, 11, 1);
        // navGraph.addEdge(3, 12, 1);
        // navGraph.addEdge(3, 13, 1);
        // navGraph.addEdge(3, 14, 1);
        // navGraph.addEdge(4, 5, 1);
        // navGraph.addEdge(4, 6, 1);
        // navGraph.addEdge(4, 7, 1);
        // navGraph.addEdge(4, 8, 1);
        // navGraph.addEdge(4, 9, 1);
        // navGraph.addEdge(4, 10, 1);
        // navGraph.addEdge(4, 11, 1);
        // navGraph.addEdge(4, 12, 1);
        // navGraph.addEdge(4, 13, 1);
        // navGraph.addEdge(4, 14, 1);
        // navGraph.addEdge(5, 6, 1);
        // navGraph.addEdge(5, 7, 1);
        // navGraph.addEdge(5, 8, 1);
        // navGraph.addEdge(5, 9, 1);
        // navGraph.addEdge(5, 10, 1);
        // navGraph.addEdge(5, 11, 1);
        // navGraph.addEdge(5, 12, 1);
        // navGraph.addEdge(5, 13, 1);
        // navGraph.addEdge(5, 14, 1);
        // navGraph.addEdge(6, 7, 1);
        // navGraph.addEdge(6, 8, 1);
        // navGraph.addEdge(6, 9, 1);
        // navGraph.addEdge(6, 10, 1);
        // navGraph.addEdge(6, 11, 1);
        // navGraph.addEdge(6, 12, 1);
        // navGraph.addEdge(6, 13, 1);
        // navGraph.addEdge(6, 14, 1);
        // navGraph.addEdge(7, 8, 1);
        // navGraph.addEdge(7, 9, 1);
        // navGraph.addEdge(7, 10, 1);
        // navGraph.addEdge(7, 11, 1);
        // navGraph.addEdge(7, 12, 1);
        // navGraph.addEdge(7, 13, 1);
        // navGraph.addEdge(7, 14, 1);
        // navGraph.addEdge(8, 9, 1);
        // navGraph.addEdge(8, 10, 1);
        // navGraph.addEdge(8, 11, 1);
        // navGraph.addEdge(8, 12, 1);
        // navGraph.addEdge(8, 13, 1);
        // navGraph.addEdge(8, 14, 1);
        // navGraph.addEdge(9, 10, 1);
        // navGraph.addEdge(9, 11, 1);
        // navGraph.addEdge(9, 12, 1);
        // navGraph.addEdge(9, 13, 1);
        // navGraph.addEdge(9, 14, 1);
        // navGraph.addEdge(10, 11, 1);
        // navGraph.addEdge(10, 12, 1);
        // navGraph.addEdge(10, 13, 1);
        // navGraph.addEdge(10, 14, 1);
        // navGraph.addEdge(11, 12, 1);
        // navGraph.addEdge(11, 13, 1);
        // navGraph.addEdge(11, 14, 1);
        // navGraph.addEdge(12, 13, 1);
        // navGraph.addEdge(12, 14, 1);
        // navGraph.addEdge(13, 14, 1);

    }


    public int? findNearest(Vector3 here)
    {
        int? nearest = null;

        if (waypoints.Count > 0)
        {
            nearest = 0;
            Vector3 there = waypoints[0].transform.position;
            float minDistance = Vector3.Distance(here, there);

            for (int i = 1; i < waypoints.Count; i++)
            {
                there = waypoints[i].transform.position;
                float distance = Vector3.Distance(here, there);
                if (distance < minDistance)
                {
                    nearest = i;
                }
            }
        }
        return nearest;
    }
}
